FLTK 1.3.7: Fl_Tiled_Image Class Reference

FLTK 1.3.7

Public Member Functions | Protected Attributes | List of all members
Fl_Tiled_Image Class Reference

This class supports tiling of images over a specified area. More...

`#include <Fl_Tiled_Image.H>`

Inheritance diagram for Fl_Tiled_Image:

## Public Member Functions
virtual void | color_average (Fl_Color c, float i)
| The color_average() method averages the colors in the image with the FLTK color value c. More...
Fl_Image * | copy ()
virtual Fl_Image * | copy (int W, int H)
| The copy() method creates a copy of the specified image. More...
virtual void | desaturate ()
| The desaturate() method converts an image to grayscale. More...
void | draw (int X, int Y)
virtual void | draw (int X, int Y, int W, int H, int cx, int cy)
| Draws a tiled image. More...
| Fl_Tiled_Image (Fl_Image *i, int W=0, int H=0)
| The constructors create a new tiled image containing the specified image. More...
Fl_Image * | image ()
| Gets The image that is tiled.
virtual | ~Fl_Tiled_Image ()
| The destructor frees all memory and server resources that are used by the tiled image.
Public Member Functions inherited from Fl_Image
Fl_Image * | copy ()
| The copy() method creates a copy of the specified image. More...
int | count () const
| The count() method returns the number of data values associated with the image. More...
int | d () const
| Returns the current image depth. More...
const char *const * | data () const
| Returns a pointer to the current image data array. More...
void | draw (int X, int Y)
| Draws the image. More...
int | fail ()
| Returns a value that is not 0 if there is currently no image available. More...
| Fl_Image (int W, int H, int D)
| The constructor creates an empty image with the specified width, height, and depth. More...
int | h () const
| Returns the current image height in pixels.
void | inactive ()
| The inactive() method calls color_average(FL_BACKGROUND_COLOR, 0.33f) to produce an image that appears grayed out. More...
virtual void | label (Fl_Menu_Item *m)
| The label() methods are an obsolete way to set the image attribute of a widget or menu item. More...
virtual void | label (Fl_Widget *w)
| The label() methods are an obsolete way to set the image attribute of a widget or menu item. More...
int | ld () const
| Returns the current line data size in bytes. More...
virtual void | uncache ()
| If the image has been cached for display, delete the cache data. More...
int | w () const
| Returns the current image width in pixels.
virtual | ~Fl_Image ()
| The destructor is a virtual method that frees all memory used by the image.

## Protected Attributes
int | alloc_image_
Fl_Image * | image_

## Additional Inherited Members
Static Public Member Functions inherited from Fl_Image
static Fl_RGB_Scaling | RGB_scaling ()
| Returns the currently used RGB image scaling method.
static void | RGB_scaling (Fl_RGB_Scaling)
| Sets the RGB image scaling method used for copy(int, int). More...
Static Public Attributes inherited from Fl_Image
static const int | ERR_FILE_ACCESS = -2
static const int | ERR_FORMAT = -3
static const int | ERR_NO_IMAGE = -1
Protected Member Functions inherited from Fl_Image
void | d (int D)
| Sets the current image depth.
void | data (const char *const *p, int c)
| Sets the current array pointer and count of pointers in the array.
void | draw_empty (int X, int Y)
| The protected method draw_empty() draws a box with an X in it. More...
void | h (int H)
| Sets the current image height in pixels.
void | ld (int LD)
| Sets the current line data size in bytes. More...
void | w (int W)
| Sets the current image width in pixels.
Static Protected Member Functions inherited from Fl_Image
static void | labeltype (const Fl_Label *lo, int lx, int ly, int lw, int lh, Fl_Align la)
static void | measure (const Fl_Label *lo, int &lw, int &lh)

## Detailed Description

This class supports tiling of images over a specified area.

The source (tile) image is not copied unless you call the color_average(), desaturate(), or inactive() methods.

## Constructor & Destructor Documentation

## ◆ Fl_Tiled_Image()

Fl_Tiled_Image::Fl_Tiled_Image | ( | Fl_Image * | i,
|  | int | W = `0`,
|  | int | H = `0`
| ) |  |

The constructors create a new tiled image containing the specified image.

Use a width and height of 0 to tile the whole window/widget.

Note
  Due to implementation constraints in FLTK 1.3.3 and later width and height of 0 may not work as expected when used as background image in widgets other than windows. You may need to center and clip the image (label) and set the label type to FL_NORMAL_LABEL. Doing so will let the tiled image fill the whole widget as its background image. Other combinations of label flags may or may not work.

#include "bg.xpm"
Fl_Pixmap *bg_xpm = new Fl_Pixmap(bg_xpm);
Fl_Tiled_Image *bg_tiled = new Fl_Tiled_Image(bg_xpm,0,0);
Fl_Box *box = new Fl_Box(40,40,300,100,"");
box->box(FL_UP_BOX);
box->labeltype(FL_NORMAL_LABEL);
box->align(FL_ALIGN_INSIDE | FL_ALIGN_CENTER | FL_ALIGN_CLIP);
box->image(bg_tiled);
FL_ALIGN_CENTER
const Fl_Align FL_ALIGN_CENTER
Align the label horizontally in the middle.
Definition: Enumerations.H:828
FL_ALIGN_CLIP
const Fl_Align FL_ALIGN_CLIP
All parts of the label that are lager than the widget will not be drawn .
Definition: Enumerations.H:847
FL_NORMAL_LABEL
@ FL_NORMAL_LABEL
draws the text (0)
Definition: Enumerations.H:762
FL_ALIGN_INSIDE
const Fl_Align FL_ALIGN_INSIDE
Draw the label inside of the widget.
Definition: Enumerations.H:841
FL_UP_BOX
@ FL_UP_BOX
see figure 1
Definition: Enumerations.H:605
Fl_Box
This widget simply draws its box, and possibly its label.
Definition: Fl_Box.H:34
Fl_Pixmap
The Fl_Pixmap class supports caching and drawing of colormap (pixmap) images, including transparency.
Definition: Fl_Pixmap.H:41
Fl_Tiled_Image
This class supports tiling of images over a specified area.
Definition: Fl_Tiled_Image.H:34
Fl_Tiled_Image::Fl_Tiled_Image
Fl_Tiled_Image(Fl_Image *i, int W=0, int H=0)
The constructors create a new tiled image containing the specified image.
Definition: Fl_Tiled_Image.cxx:57
Fl_Widget::image
Fl_Image * image()
Gets the image that is used as part of the widget label.
Definition: Fl_Widget.H:514
Fl_Widget::align
Fl_Align align() const
Gets the label alignment.
Definition: Fl_Widget.H:348
Fl_Widget::box
Fl_Boxtype box() const
Gets the box type of the widget.
Definition: Fl_Widget.H:363
Fl_Widget::labeltype
Fl_Labeltype labeltype() const
Gets the label type.
Definition: Fl_Widget.H:456

Note
  Setting an image (label) for a window may not work as expected due to implementation constraints in FLTK 1.3.x and maybe later. The reason is the way Fl::scheme() initializes the window's label type and image. A possible workaround is to use another Fl_Group as the only child widget and to set the background image for this group as described above.

Todo:
  Fix Fl_Tiled_Image as background image for widgets and windows and fix the implementation of Fl::scheme(const char *).

## Member Function Documentation

## ◆ color_average()

void Fl_Tiled_Image::color_average | ( | Fl_Color | c,
|  | float | i
| ) |  |
| virtual

The color_average() method averages the colors in the image with the FLTK color value c.

The i argument specifies the amount of the original image to combine with the color, so a value of 1.0 results in no color blend, and a value of 0.0 results in a constant image of the specified color.

An internal copy is made of the original image before changes are applied, to avoid modifying the original image.

Reimplemented from Fl_Image.

## ◆ copy()

Fl_Image * Fl_Tiled_Image::copy | ( | int | W,
|  | int | H
| ) |  |
| virtual

The copy() method creates a copy of the specified image.

If the width and height are provided, the image is resized to the specified size. The image should be deleted (or in the case of Fl_Shared_Image, released) when you are done with it.

Reimplemented from Fl_Image.

## ◆ desaturate()

void Fl_Tiled_Image::desaturate | ( |  | ) |
| virtual

The desaturate() method converts an image to grayscale.

If the image contains an alpha channel (depth = 4), the alpha channel is preserved.

An internal copy is made of the original image before changes are applied, to avoid modifying the original image.

Reimplemented from Fl_Image.

## ◆ draw()

void Fl_Tiled_Image::draw | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | int | cx,
|  | int | cy
| ) |  |
| virtual

Draws a tiled image.

Tiled images can be used as background images for widgets and windows. However, due to implementation constraints, you must take care when setting label types and alignment flags. Only certain combinations work as expected, others may yield unexpected results and undefined behavior.

This draw method can draw multiple copies of one image in an area given by `X`, `Y`, `W`, `H`.

The optional arguments `cx` and `cy` can be used to crop the image starting at offsets (cx, cy). `cx` and `cy` must be >= 0 (negative values are ignored). If one of the values is greater than the image width or height resp. (`cx` >= image()->w() or `cy` >= image()->h()) nothing is drawn, because the resulting image would be empty.

After calculating the resulting image size the image is drawn as often as necessary to fill the given area, starting at the top left corner.

If both `W` and `H` are 0 the image is repeated as often as necessary to fill the entire window, unless there is a valid clip region. If you want to fill only one particular widget's background, then you should either set a clip region in your draw() method or use the label alignment flags `FL_ALIGN_INSIDE|FL_ALIGN_CLIP` to make sure the image is clipped.

This may be improved in a later version of the library.

Reimplemented from Fl_Image.

The documentation for this class was generated from the following files:

- Fl_Tiled_Image.H
- Fl_Tiled_Image.cxx

- Copyright © 1998-2021 by Bill Spitzak and others.